package str.classtree;

import java.io.FileInputStream;
import java.io.InputStream;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.io.IOException;

import str.classtree.classify.ClassClassifier;
import static str.aterm.ATermUtil.*;
import org.apache.bcel.classfile.*;
import org.apache.bcel.generic.*;
import aterm.*;

public class ATerm2Class
{
  public static void main (String args[])
  {
    try
    {
      if(args.length != 4 || !args[0].equals("-i") || !args[2].equals("-o"))
      {
        System.err.println("aterm2class: You must specify 4 arguments: -i in -o out");
        System.exit(1);
      }

      InputStream in = new FileInputStream(args[1]);
      OutputStream out = new FileOutputStream(args[3]);
      writeClass(convert(_factory.readFromFile(in)), out);
      in.close();
      out.close();
    }
    catch(Exception exc)
    {
      System.err.println("aterm2class: Oops. Something went wrong! Let me explain that:");
      exc.printStackTrace();
      System.err.println("aterm2class: Exiting gracefully.");
      System.exit(1);
    }
  }
  
  public static String asm(String inputFile, String outputFile)
  {
    String[] args = { "-i", inputFile, "-o", outputFile };
    main(args);
    return "\"" + outputFile + "\"";
  }

  private static void writeClass(JavaClass clazz, OutputStream stream) throws IOException 
  {
    clazz.dump(stream);
  }    

  private static JavaClass convert(ATerm term) throws IOException 
  {
    ClassClassifier classifier = new ClassClassifier();
    return classifier.convert(term);
  }
}
