package str.classtree.atermify;

import org.apache.bcel.classfile.*;
import org.apache.bcel.generic.*;
import aterm.*;
import static str.classtree.atermify.ATermifyUtil.*;
import str.aterm.ATermifier;
import static str.aterm.ATermUtil.*;

public class MethodATermifier implements ATermifier<Method>
{
  private ConstantPool _pool;

  public MethodATermifier(ConstantPool pool)
  {
    super();
    _pool = pool;
  }

  public ATerm convert(Method method)
  {
    MethodAttributeATermifier aattrs = new MethodAttributeATermifier(method, _pool);

    ATerm result = appl("Method",
      appl("AccessFlags", buildFlags(method)),
      appl("Name", astring(method.getName())),
      buildMethodDescriptor(method),
      appl("Attributes", aattrs.map(method.getAttributes()))
    );

    return result;
  }
}
